use super::source::Source;

#[derive(Debug)]
pub enum Object<'s> {
    #[allow(dead_code)]
    TextMarkup(TextMarkup<'s>),

    PlainText(PlainText<'s>),

    #[allow(dead_code)]
    RegularLink(RegularLink<'s>),
}

#[derive(Debug)]
pub struct TextMarkup<'s> {
    pub source: &'s str,
}

#[derive(Debug)]
pub struct PlainText<'s> {
    pub source: &'s str,
}

#[derive(Debug)]
pub struct RegularLink<'s> {
    pub source: &'s str,
}

impl<'s> Source<'s> for Object<'s> {
    fn get_source(&'s self) -> &'s str {
        match self {
            Object::TextMarkup(obj) => obj.source,
            Object::PlainText(obj) => obj.source,
            Object::RegularLink(obj) => obj.source,
        }
    }
}
